import { select, json, tsv, geoPath, geoNaturalEarth1, zoom, event } from 'd3';
import {feature} from 'topojson';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g')
g.append('path')
.attr('class','sphere')
.attr('d', pathGenerator({type: 'Sphere'}));


svg.call(zoom().on('zoom',()=>{
g.attr('transform', d3.event.transform)
}))

Promise.all([
tsv('https://unpkg.com/world-atlas@1/world/110m.tsv'),
  json('https://unpkg.com/world-atlas@1/world/110m.json')
]).then(([tsvData,topoJSONdata])=>{
  
  const countryName = tsvData.reduce((accumulator,d)=>{
  accumulator[d.iso_n3]=d.name;
    return accumulator;
  },{})
  
  /*
  const countryName = {}
  
  tsvData.map(d=>{
  countryName[d.iso_n3]=d.name;
  })
*/
  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries)
  
  const paths = g.selectAll('path')
  .data(countries.features);
  
  paths.enter().append('path')
  .attr('class','country')
  .attr('d', d=>pathGenerator(d))
  .append('title')
  .text(d=>countryName[d.id])

})




